function varargout = canresistance(varargin)
%this GUI needs the vdepRC.m function to calculate the canopy resistance RC
% (C) Thomas Karl, NCAR, 2009 - www.tomkarl.com

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @canresistance_OpeningFcn, ...
                   'gui_OutputFcn',  @canresistance_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before canresistance is made visible.
function canresistance_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to canresistance (see VARARGIN)
% Default values
%G=800; Ts=30; HLC=10; Dx=1.6; f0=0; landcover=4;
% Choose default command line output for canresistance
handles.output = hObject;

% Update handles structure

handles.R=800;
handles.Ts=30;
handles.HLC=10;
handles.Dx=1.6;
handles.f0=0;
handles.landcover=1;
handles.season=1;
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
guidata(hObject, handles);

%handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover);
%set(handles.Rc, 'String', handles.output);
% UIWAIT makes canresistance wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = canresistance_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function R_Callback(hObject, eventdata, handles)
% hObject    handle to R (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
G = str2double(get(hObject, 'String'));
if isnan(G)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

if G>800
    G=800;
elseif G<0
    G=0;
end
% Save the new radiation value
handles.R = G;

guidata(hObject,handles)
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);

% Hints: get(hObject,'String') returns contents of R as text
%        str2double(get(hObject,'String')) returns contents of R as a double

% --- Executes during object creation, after setting all properties.
function R_CreateFcn(hObject, eventdata, handles)
% hObject    handle to R (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ts_Callback(hObject, eventdata, handles)
% hObject    handle to Ts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Ts = str2double(get(hObject, 'String'));
if isnan(Ts)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
if Ts>39.9
    Ts=39.9;
elseif Ts<-10
    Ts=-10;
end

% Save the new temperature value
handles.Ts = Ts;
guidata(hObject,handles);
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);

% Hints: get(hObject,'String') returns contents of Ts as text
%        str2double(get(hObject,'String')) returns contents of Ts as a double


% --- Executes during object creation, after setting all properties.
function Ts_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function HLC_Callback(hObject, eventdata, handles)
% hObject    handle to HLC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
HLC = str2double(get(hObject, 'String'));
if isnan(HLC)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
if HLC<0
    HLC=0;
end
% Save the new HLC value
handles.HLC = HLC;
guidata(hObject,handles);
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);

% Hints: get(hObject,'String') returns contents of HLC as text
%        str2double(get(hObject,'String')) returns contents of HLC as a double


% --- Executes during object creation, after setting all properties.
function HLC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to HLC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Dx_Callback(hObject, eventdata, handles)
% hObject    handle to Dx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Dx = str2double(get(hObject, 'String'));
if isnan(Dx)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
if Dx>5
    Dx=5;
elseif Dx<0
    Dx=0;
end

% Save the new Dx value
handles.Dx = Dx;
guidata(hObject,handles);% Hints: get(hObject,'String') returns contents of Dx as text
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);
%        str2double(get(hObject,'String')) returns contents of Dx as a double


% --- Executes during object creation, after setting all properties.
function Dx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Dx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function f0_Callback(hObject, eventdata, handles)
% hObject    handle to f0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
f0 = str2double(get(hObject, 'String'));
if isnan(f0)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
if f0>=1
    f0=1;
elseif f0<=0
    f0=0;
end
% Save the new f0 value
handles.f0 = f0;
guidata(hObject,handles);
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);
% Hints: get(hObject,'String') returns contents of f0 as text
%        str2double(get(hObject,'String')) returns contents of f0 as a double


% --- Executes during object creation, after setting all properties.
function f0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to f0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in landcover.
function landcover_Callback(hObject, eventdata, handles)
% hObject    handle to landcover (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
         str = get(hObject, 'String');
         val = get(hObject,'Value');
         % Set current data to the selected data set.
         switch str{val};
             case 'Urban Land (1)' % User selects Peaks.
                 landcover = 1;
             case 'Agricultural Land (2)'
                 landcover = 2;
             case 'Range Land (3)'
                 landcover = 3;
             case 'Deciduous Forest (4)'
                 landcover = 4;
             case 'Coniferous Forest (5)'
                 landcover = 5;
             case 'Mixed Forest incl Wetland (6)'
                 landcover = 6;
             case 'Water (7)'
                 landcover = 7;
             case 'Barren land (8)'
                 landcover = 8;
             case 'Nonforested Wetland (9)'
                 landcover = 9;
             case 'Mixed Agricultural and Range Land (10)'
                 landcover = 10;
             case 'Rocky Open Areas with Low-growing Shrubs (11)'
                 landcover = 11;
         end
% Hints: contents = get(hObject,'String') returns landcover contents as cell array
%        contents{get(hObject,'Value')} returns selected item from
%        landcover

handles.landcover = landcover;
guidata(hObject,handles);
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);


% --- Executes during object creation, after setting all properties.
function landcover_CreateFcn(hObject, eventdata, handles)
% hObject    handle to landcover (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Rc_Callback(hObject, eventdata, handles)
% hObject    handle to Rc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Rc as text
%        str2double(get(hObject,'String')) returns contents of Rc as a double



% --- Executes during object creation, after setting all properties.
function Rc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Rc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in season.
function season_Callback(hObject, eventdata, handles)
% hObject    handle to season (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
str = get(hObject, 'String');
         val = get(hObject,'Value');
         % Set current data to the selected data set.
         switch str{val};
             case 'Season(1) Midsummer with Lush Vegetation' % User selects Peaks.
                 season = 1;
             case 'Season(2) Autumn with Unharvested Cropland'
                 season = 2;
             case 'Season(3) Late Autumn Afetr Frost - No Snow'
                 season = 3;
             case 'Season(4) Winter, Snow on Ground and Subfreezing'
                 season = 4;
             case 'Season(5) Transitional Spring with Partially Green Short Annuals'
                 season = 5;
         end
         
handles.season = season;
guidata(hObject,handles);
handles.output = vdepRC(handles.R, handles.Ts, handles.HLC, handles.Dx, handles.f0, handles.landcover, handles.season);
set(handles.Rc, 'String', handles.output);

% Hints: contents = get(hObject,'String') returns season contents as cell array
%        contents{get(hObject,'Value')} returns selected item from season


% --- Executes during object creation, after setting all properties.
function season_CreateFcn(hObject, eventdata, handles)
% hObject    handle to season (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
